#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <sys/time.h>

#define a(i,j)  a[ (j) + (i)*lda ]
#define b(i,j)  b[ (j) + (i)*lda ]
#define c(i,j)  c[ (j) + (i)*lda ]

double mysecond()
{
        struct  timeval  tp;
        struct timezone tzp;
        int i;

        i = gettimeofday(&tp,&tzp);
        return ( (double) tp.tv_sec + (double) tp.tv_usec * 1.e-6 );
}


void matgen(char cmat, int m, int n, int lda, double *a){

      int ir, ic;

//    Working with only square matrices

      double  factor;

      factor = 1.0e0/sqrt( (double)n );
//    Constant Rows
      if(cmat == 'a') {
         for( ir = 0; ir<m; ir++){
         for( ic = 0; ic<n; ic++){
            a(ir,ic) = (double)(ir+1)*factor;
         }
         }
      }

//    Constant Columns
      if(cmat == 'b') {
         for( ir = 0; ir<m; ir++){
         for( ic = 0; ic<n; ic++){
            a(ir,ic) = (double)(ic+1)*factor;
         }
         }
      }

      if(cmat == 'c') {
         for( ir = 0; ir<m; ir++){
         for( ic = 0; ic<n; ic++){
            a(ir,ic) = 0.0e0;
         }
         }
      }



}


void mxm(int m,int n,int k,int lda,
                  double *a,
                  double *b,
                  double *c){


      int ir, ic, inner;

//    Working with only square matrices

      for( ir    = 0; ir   < m; ir++   ){
      for( ic    = 0; ic   < n; ic++   ){
      for( inner = 0; inner< k; inner++){
          c(ir,ic) = c(ir,ic) + a(ir,inner)*b(inner,ic);
      }
      }
      }
}
